require 'thor'
require 'nerd_flirt/main.rb'
require 'nerd_flirt/server.rb'
require 'nerd_flirt/printer.rb'

class CLI < Thor

  desc "server", "Starts NerdFlirt server"
  def self.server(port)
    puts "---------------------------------------------"
    puts "• Starting NerdFlirt server on port #{port.to_s}"
    NerdFlirt::Server.new(port)
  end

  desc "run!", "Starts NerdFlirt client"
  def self.run!(host = '127.0.0.1', port = 8000)
    puts "---------------------------------------------"
    puts "NerdFlirt client connecting to #{host}:#{port}"
    puts "---------------------------------------------"
    NerdFlirt::Main.new.start
  end
end
