require 'socket'
class NerdFlirt::Client
  attr_accessor :user

  COMMANDS = %w[/exit /help]

  def initialize(server, user_name)
    @user = user
    @server = server
    @request = nil
    @response = nil

    @server.puts user_name

    listen
    send

    @request.join
    @response.join
  end

  def listen
    @response = Thread.new do
      loop {
        msg = @server.gets.chomp
        puts "#{msg}"
      }
    end
  end

  def send
    @request = Thread.new do
      loop {
        print "> ".colorize(:magenta)
        input = $stdin.gets.chomp

        command = false
        if COMMANDS.include?(input)
          self.public_send(input)
          command = true
        end

        @server.puts input unless command
      }
    end
  end

  def exit
    puts "bye!"
    exit
  end

  def help
    # show help text
  end

  def server=(server)
    @server = server
  end

  def server
    @server
  end
end
