require 'nerd_flirt/user.rb'
require 'nerd_flirt/client.rb'

class NerdFlirt::Main
  attr_accessor :user

  def start
    welcome
    view_menu

    if new_user?
      new_user_prompt
    end

    find_match
    input?
  end

  def welcome
    system "clear" unless system "cls"
    printer.banner
    sleep 2
  end

  def new_user?
    # check json file for user
    true
  end

  def new_user_prompt
    printer.four_breaks
    printer.text "You will need to enter 4 lines of information for your nerd flirt: your gender, age, name and a opening question.", nil, true
    puts "\n"
    sleep 3
    printer.line
    printer.four_breaks

    puts "Gender (m/f):"
    print '> '
    gender = $stdin.gets.chomp

    puts "Name:"
    print '> '
    name = $stdin.gets.chomp

    puts "Age:"
    print '> '
    age = $stdin.gets.chomp

    puts "Now enter the first question you would like to ask your flirt."
    print '> '
    question = $stdin.gets.chomp

    self.user = NerdFlirt::User.new name: name, gender: gender, age: age

    printer.text "Smooth. Ok let's see what we got here, #{user.name}", :magenta
    printer.loading_dots
    puts "\n"
  end

  def find_match
    printer.line
    puts "\n"
    print "\n"

    server = TCPSocket.open('127.0.0.1', 8000) # ENV['SERVER_IP'], ENV['SERVER_PORT']
    NerdFlirt::Client.new(server, user.name)

    puts "\n"
    printer.line

    view_menu

    puts "\n"
    printer.line

    puts "\n\n\n\n"
  end

  def view_menu
    puts "\n"
    puts 'Menu:'.colorize :magenta
    printer.text '/new = find new flirt'
    print "\n"
    printer.text '/exit = quit application'
  end

  def input?
    print '> '.colorize :yellow
    input = $stdin.gets.chomp()

    input?
  end

  def printer
    @printer ||= NerdFlirt::Printer
  end
end
