require 'terminfo'
require 'colorize'

class NerdFlirt::Printer
  def self.line
    terminal_width.times do
      print '-'.colorize(:light_blue)
      sleep 0.01
    end
  end

  def self.text(str, color = :white, center = false)
    if center
      ((terminal_width / 2) - (str.length / 2)).times { print ' '}
    end

    str.split.each do |word|
      word.split("").each do |char|
        print char.colorize( color )
        sleep(0.01)
      end
      print " "
    end
  end

  def self.banner
    line
    print "\n"

    text("Welcome to Nerd♥Flirt", :magenta, true)
    system 'say -v Vicki "Welcome, to nerd flirt."'

    print "\n"
    tag_line
    #system 'say -v Vicki "sudo, find love"'

    print "\n"
    line
  end

  def self.four_breaks
    print "\n\n\n\n"
  end

  def self.loading_dots
    10.times do |n|
      print '.'
      sleep 0.4
    end
  end

  def self.tag_line
    text "$ sudo find love", :white, true
  end

  def self.terminal_width
    TermInfo.screen_size[1]
  end
end
